% % paper information
% % Qingxiang Feng and yicong zhou, Kernel Regularized Data Uncertainty for Action Recognition, IEEE TCSVT
% % fengqx1988@gmail.com and yicongzhou@umac.mo

% % % Produce the random train and test data
samdim=200;
class=10;

Jtrain=rand(samdim,5*class);
trlab=ones(5,1)*[1:class];
trlab=trlab(:)';

Jtest=rand(samdim,10*class);
ttlab=ones(10,1)*[1:class];
ttlab=ttlab(:)';
% % % End of Producing the random train and test data

% % % Constitute the virtual samples
[JtrainV,trlabV]=ToVirSam(Jtrain,trlab);

% % % Compute the recognition rate of RDU and RDUC as
[rateRDU,RateRDUC]=RDUme(Jtest,JtrainV,ttlab,trlabV,0.25,0.01)


% % %  Compute the recognition rate of KRDU and KRDUC as

[~,alltrainsamnum]=size(JtrainV);
[~,alltestsamnum]=size(Jtest);

% % % compute the kernel parameter
meansam=mean(JtrainV,2);
paraarr=zeros(1,alltrainsamnum);
for i=1:alltrainsamnum
    paraarr(i)=1/norm(JtrainV(:,i)-meansam)^2;
end
canshu=mean(paraarr)/9;

% % % constitute kernel matrix of train
Ktrain=zeros(alltrainsamnum,alltrainsamnum);
for ik=1:alltrainsamnum
    for jk=ik:alltrainsamnum
        x=JtrainV(:,ik)';
        y=JtrainV(:,jk)';
        Ktrain(ik,jk)=kernel(x,y,canshu);
        Ktrain(jk,ik)=Ktrain(ik,jk);
    end
end

% % % constitute kernel matrix of test
Ktest=zeros(alltrainsamnum,alltestsamnum);
for ik=1:alltestsamnum
    for jk=1:alltrainsamnum
        x=Jtest(:,ik)';
        y=JtrainV(:,jk)';
        Ktest(jk,ik)=kernel(x,y,canshu);
    end
end

[rateKRDU,RateKRDUC]=RDUme(Ktest,Ktrain,ttlab,trlabV,0.25,0.01)