function [rateres,ratecoef]=RDUme(Jtest,Jtrain,ttlab,trlab,thre,lamba)
% % paper information
% % Qingxiang Feng and yicong zhou, Kernel Regularized Data Uncertainty for Action Recognition, IEEE TCSVT
% % fengqx1988@gmail.com and yicongzhou@umac.mo

% if nargin < 5
%     lamba = 0.25 ;
% end
% 
% if nargin < 6
%     lamba = 0.01 ;
% end

class=length(unique(trlab));
[~,alltrainsamnum]=size(Jtrain);
[~,alltestsamnum]=size(Jtest);
% sample_num=ceil(alltrainsamnum/class);

labres=zeros(1,alltestsamnum);
labcoef=zeros(1,alltestsamnum);
for itest=1:alltestsamnum
    Ip=Jtest(:,itest);
    
    W=zeros(alltrainsamnum,alltrainsamnum);
    for i=1:alltrainsamnum
        W(i,i)=norm(Ip-Jtrain(:,i))^2;
    end

%     cofF=inv(Jtrain'*Jtrain+W*lamba)*Jtrain'*Ip;
%     cof_final=inv(J_arr'*J_arr+0.01*eye(class))*J_arr'*I;

    disfirstphasearr=zeros(1,alltrainsamnum);
    for i=1:alltrainsamnum
%         disfirstphasearr(i)=norm(Ip-Jtrain(:,i)*cofF(i));
        disfirstphasearr(i)=W(i,i)^0.5;
    end

    [~, firstphaselab]=sort(disfirstphasearr,'ascend');

    selectnum=ceil(thre*alltrainsamnum);
    Jtrain_sp=Jtrain(:,firstphaselab(1:selectnum));
    W_sp=W(firstphaselab(1:selectnum),firstphaselab(1:selectnum));
    cofS=inv(Jtrain_sp'*Jtrain_sp+W_sp*lamba)*Jtrain_sp'*Ip;

    % classlab=ceil(firstphaselab(1:selectnum)/sample_num);
    classlab=trlab(firstphaselab(1:selectnum));

    dissparr=zeros(1,class);
    cofsparr=zeros(1,class);
    for i=1:class
        temfinlab=find(classlab==i);
        [finlab1, finlab2]=size(temfinlab);
        if finlab1*finlab2==0
            dissparr(i)=10000000000;
            cofsparr(i)=-10000000000;
        else
            Jtemi=Jtrain_sp(:,temfinlab);
            cofStemi=cofS(temfinlab);

            dissparr(i)=norm(Ip-Jtemi*cofStemi);
            cofsparr(i)=sum(cofStemi);
        end
    end

    index=find(dissparr==min(dissparr));
    labres(itest)=index(1);

    index2=find(cofsparr==max(cofsparr));
    labcoef(itest)=index2(1);
end

rateres=sum(labres==ttlab)/length(ttlab);
ratecoef=sum(labcoef==ttlab)/length(ttlab);